{{
   BBQ Controller
   Written May-June-July 2008 by Chuck Rice
  
   Based on code and hardware examples by many people including:
   Jon Williams, Chip Gracey, Beau Schwabe, Jose Pino, Martin Hebel,
   Steve Nicholson, Robert Quattlebaum, Michael Green, and many others!

  ************************************************************** 
  **                                                          **     
  **       !!! WARNING !!! PROCEED AT YOUR OWN RISK!          **     
  **                                                          **     
  **     This project deals with hazardous and dangerous      **     
  **           materials and electrical devices.              **    
  **                                                          **     
  **          If you "Try this at Home", be sure              **     
  **     to get a qualified person to review this design      **    
  **                and your implementation.                  **    
  **                                                          **     
  **         The death you prevent may be your own            **     
  **                  (or your loved one)                     **     
  **                                                          **     
  **         You are responsible for your own actions.        **     
  **                                                          **     
  **************************************************************
  
}}

con 
{{
                       ┌────────────────────────────────────┐
                       │ Propane/Butane Controller Overview │
                       └────────────────────────────────────┘
                                   Propeller
                                   Proto Board     6V 2A
             FrobKnob             ┌───────────┐      
               ─────────────────╋           ╋──────┘                
             ┌─────┐              │   ┌────┐  ╋─────────→ Gnd                      
             │7-seg┣──────────────╋   │    │  ╋───────────────────────────────────────────────┐                      
             └─────┘              │   └────┘  ╋─────────────────────────────────────────────┐ │
             Display              │           ╋─────────────────────────────────────────┐   │ │
                       Supply     └─╋─╋─────╋─┘                                         │   │ │
                       1.2A 12V     │ │     │                                           │   │ │
                                   │ │     │Servo 6V                                   │   │ │
                             └──────┘ │     │Control/Power/Ground                       │   │ │
                             ┌──────┐ │     │                                           │   │ │
                                   │ │     │                                           │   │ │
                            Gnd     │ │     │                                           │   │ │Type K
                                    │ │     │                                           │   │ │Thermocouple
                                    │ │     │                                           │   └V┘                  
                    Low Pressure    │ │     │    Needle (upside down)                   │                  
                    Regulator      ┌┻─┻┐    │    Valve                        Burner    │                       
                                  └┐│┌┘    │                                      │                                 
         ┌┬┐          ┌───┐         ├│┤     │                                  │                                 
         ┌┼┴│    │                                             
     ┌───┘┻└───┐      └───┘      Emergency  │   ┌┌┴┐┐  ←── Needle valve           640Ω                 
     │ BBQ     │                  Shutoff   │   └─┬─┘      handle & servo           │ ┌──── 1.5 volt Battery       
     │ Propane │                 (deadman)  │    ┌┴────┐   epoxied together            │ │      250 mA                                                   
     │ Tank    │                            └────┫Servo│                       Spark    └                                    
     └┐───────┌┘                                 └─────┘                         │        │                     
      └───────┘                                   1.8A      IGBIB4-B Igniter→ ┌────────┫
                                                                              │            47kΩ
                                                                                                      
                                                                             Gnd         Gnd                    
                                                                                        
           ┌──────────────────────────────────────────────────────────────────┐         
           │  Note: Any wire that might come into contact with hot surfaces   │                                       
           │        must be rated for High Temperature. Generally this will   │            2
           │        need to be Teflon/Fiberglass.                             │ 
           │        Reference: http://www.gaumer.com/                         │ 
           └──────────────────────────────────────────────────────────────────┘                                                                
               
}}
con 
{{
                       ┌─────────────────────────┐
                       │          Parts          │
                       └─────────────────────────┘ 


Following is a partial list of parts I used on my project,
noted for my future reference. These are not specific recommendations
for any of these suppliers,they are just the ones I used.
Substitute as desired. 

┌─────────────────────────────┐                                                                                                                          
│ Partial Project Parts List  │
└─────────────────────────────┘
 QTY Approx Description                            Source          PartNumber     WebPage
 --- ------ -------------------------------------- --------------  -------------  ----------------------
  1  $19.95 ProtoBoard                             Parallax        32212          http://www.parallax.com/Store/Microcontrollers/PropellerDevelopmentBoards/tabid/514/CategoryID/73/List/0/Level/a/ProductID/423/Default.aspx?SortField=ProductName%2cProductName  
  1   11.95 Max6675 Thermocouple Amplifier Digital Spark Fun       COM-00307      http://www.sparkfun.com/commerce/product_info.php?products_id=307
  1   13.95 Thermocouple Type-K Glass Braid        Spark Fun       SEN-00251      http://www.sparkfun.com/commerce/product_info.php?products_id=251
  1    2.95 SOIC to DIP Adapter 8-Pin              Spark Fun       BOB-00494      http://www.sparkfun.com/commerce/product_info.php?products_id=494
  1    2.40 LED 7-SEG .4inch 4 Digit Super Red CA  Digi-Key        60-1550-5-ND   http://search.digikey.com/scripts/DkSearch/dksus.dll?Detail?name=160-1550-5-ND                             
  1   22.60 Valve 1/4inch MF NPT 12 Volt Propane   US Carburetion  VALVE-14-12SS  www.propane-generators.com/rsk-hp.htm
  1 ~350.00 Comalco Quad-Que Fireplace Grill       Colcal          4747           http://www.factorydirect2you.com/cogr47.html
  1   10.00 Low pressure propane regulator         Fireplace shop
  1  ~10.00 2-Gang Exterior Junction box           Home Depot  
  1  ~10.00 2-Gang Exterior Outlet Cover           Home Depot                     Multi-Mac (with clear door)
  1    2.95 Piezo Speaker                          Lynxmotion      COMP-02
  1   19.95 Battery Powered Igniter                local BBQ Shop  IGBIB4-B


   
┌───────────────────────┐
│   Junk drawer items   │
└───────────────────────┘
1N4001-1N4007 - 1 Amp Diode Assortment Kit - 175 Diodes     (SKU# 005440) = $14.99
1/8W Carbon Film Resistor Assortment Kit   - 2500 Resistors (SKU# 005420) = $19.99 (1/8 watt are rather small. get 1/4 watt)
Electrolytic Capacitor Assortment Kit      - 350 Capacitors (SKU# 005370) = $15.95
Teflon wire (I scored a spool of it at an electronics surplus store years ago)
HiTec Sailwinch Servo HS-725BB or HS-785HB  (Left over from a previous project)

}}


con 
{{
                       ┌─────────────────────────┐
                       │  Temperature Subsystem  │
                       └─────────────────────────┘ 

  3.3v
          ┌───────┐
   └─────┳─┤Vcc    │
    0.1µf │     SO├─── Pin 8
   ┌─────┣─┤Gnd  __│
        │ │     CS├─── Pin 9                                                                                                               
  Gnd  ┌─┻─┤T-     │
       │   │    SCK├─── Pin 10                                                                                                               
       │ ┌─┤T+     │
       │ │ └───────┘
       │ │  MAX6675
       │ │
       └V┘
      Type K
   Thermocouple    

   Note: The MAX6675 is an SOIC package, so the chip is soldered onto a
         breakout board from Spark Fun SKU#: BOB-00494

}}


con 
{{
                       ┌─────────────────────────┐
                       │    Display Subsystem    │
                       └─────────────────────────┘ 

                   ┌────────────────────────────────── Pin 0
                   │    ┌───────────────────────────── Pin 1
                   │    │      ┌────────────────────── Pin 2
                   │    │      │      ┌─────────────── Pin 3
                   │    │      │      │    ┌────────── Pin 4
                   │    │      │      │    │                        
                   │1   │2     │4     │6   │8                  <--- Anodes
             ┌─────┴────┴──────┴──────┴────┴─────┐
  4-Digit    │    dg1  dg2   3LEDs   dg3  dg4    │
  7-Segment  │                                   │
  Display    │ sg1...........................sg8 │
             └──┬───┬───┬───┬───┬───┬───┬───┬────┘             <--- Cathodes
   SegmentPin-> │a  │b  │c  │d  │e  │f  │g  │dp
          pin-> │14 │16 │13 │3  │5  │11 │15 │7                   
          LED-> │L1 │L2 │L3 │   │   │   │   └─────── Pin 23
                │   │   │   │   │   │   └─────────── Pin 22
                │   │   │   │   │   └─────────────── Pin 21
                │   │   │   │   └─────────────────── Pin 20
                │   │   │   └─────────────────────── Pin 19
                │   │   └─────────────────────────── Pin 18
                │   └─────────────────────────────── Pin 17
                └─────────────────────────────────── Pin 16
             
      Current limiting resistors should be between 39 and 68 ohm for 3.3V operation

}}
con 
{{
                       ┌─────────────────────────┐
                       │ Emergency Shutoff Valve │
                       └─────────────────────────┘

Propane High Pressure Shutoff Valve Description:
        
        1/4 inch Male x Female NPT Brass Body       
        Rated for gas pressure up to 250 psi
        12V Low  8 Watt Power Consumption
        UL Listed Fuel Valve

        Normally Closed (requires 12V to open)

                                   2Amp
                660Ω ┌────────┐    Fuse    12V    
       Pin x o─────┤┐      ┌├────~~────┤────────┐      This is a "deadman" emergency         
                     │    ││                      │      shutoff. If power is lost, it   
       Gnd   o───────┤┘      └├────────────────────┐ │      automatically shuts off the gas
                     │        │                    │ │      or the pgm can shut it off if it                                                                          
                  ───┤┐      ┌├───                ┌┻─┻┐     sees an error condition such as  
            Not Used │    ││ Not Used          └┐│┌┘     over temperature or gas on and                                                                                              
                  ───┤┘      └├───                 ├│┤      no heat detected.   
                     └────────┘                 ───┘┼└───   
                       AQW272                   ─────────                                                         
                      PhotoMOS               Propane Shutoff 
                       Relay                  Valve-14-12SS
                         

}}


con 
{{
                       ┌───────────────┐
                       │ Flame Control │
                       └───────────────┘

                         14-12SS
                         Needle Valve
                         Attached
                         to Servo 
                             
      Regulated         ┌─────────┐                                    
      Low Pressure      │       │        Low Pressure                               
      Propane In ──→     ──→ Propane Out                                
                        │       │
                        │         │
                        │  Sail   │
                        │  Winch  │
                        │  Servo  │
                        └─────────┘
                         Top View


}}
con 
{{
                       ┌──────────────┐
                       │   FrobKnob   │
                       └──────────────┘
The frobknob is a 2-bit quadrature encoder device with a pushbutton switch.
This is the main input control for the device. Turning it selects functions
or values. Pushing the switch activates the currently displayed selection.
I cannot remember if I used Pullups (as shown) or Pulldowns. You may have
to fiddle with the code to match the wiring. 


                3.3V
              ────────     
                   
                                            ←─ 10 kΩ
              │    │ │            ┐
              │    ┣─────── Pin 25│ Encoder
            ┌────┐ │ ┣───── Pin 26│
            │ │ ┌┻─┻─┻┐           ┘
            │ │ │  O  │                        ←─ 2-bit encoder 
            │ │ └─┳─┳─┘           ┐
            │ └───┴─│────── Pin 31│ Pushbutton
                                ┘
            ──────────
               Gnd
                  
      │ ╋    ┣ ╋ ┫ ┻ ┳ ├─── ┼ ───┤ ┴ ┬ ┌────┐ └────┘                   •   ← → ↑ ↓         
                 
}}                       
con 
{{
                       ┌───────────────┐
                       │ Audio Control │
                       └───────────────┘
  References:
        http://www.josepino.com/circuits/index.php?mini_amplifier_lm386.jpc
        http://www.parallax.com/Portals/0/Downloads/docs/cols/nv/vol2/col/nv67.pdf


                                            +4Vto18V
                          Boost                 
                          Swich     +           │
                       ┌───────────┤(────┐    │
                       │            10µF   │    │
             Volume    │  1┌─────v─────┐8  │    │
             Adjust    └───┤Gain   Gain├───┘    │
                          │           │        │
     Input o───┐       ┌───┤-In  Bypass├── NC   │
               │  .1µF │   │           │        │
         100kΩ ←─────│───┤+in      +V├──┳─────┘
               │       │   │           │  │     +
       Gnd o───┴───────╋───┤Gnd     Out├─────────┤(──┐  /┐
                       │  4└───────────┘5 │    220µF └┼/ │
                       │       LM386      │           │  │ Speaker
                       │             .1µF         ┌┼\ │ 8 to 30 Ω
                       └──────────────────┻──────────┘  \┘
                     

}}                                                                                                                        

CON

  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
  


' Seven Segment Display Digit Pins   
  lowDigitPin0          = 0                     'Lowdigit Pins are the Anodes
  lowDigitPin1          = 1  
  lowDigitPin2          = 2  
  lowDigitPin3          = 3  
  lowDigitPin4          = 4  
' Reserved              = 5                         
  igniterPin            = 6                         
  propaneDeadManCutoff  = 7
' 1                     2           3           4           5           6           7           8           9           10         
                          
' MAX6675/Type K Thermocouple Pins
  so_data_pin           = 8  
  cs_rst_pin            = 9  
  clk_pin               = 10
   
' Speaker Pin
  speakerPin            = 11 
' Reserved              = 12                         
' Reserved              = 13                         
  cXBEEtx               = 14                         
  cXBEErx               = 15                         
                         
' Seven Segment Display Segment Pins   
  SegmentPin0           = 16                'Segment start pin (allocates 8 pins starting with this pin number)
  SegmentPin1           = 17                
  SegmentPin2           = 18                
  SegmentPin3           = 19                
  SegmentPin4           = 20                
  SegmentPin5           = 21                
  SegmentPin6           = 22                
  SegmentPin7           = 23
                 
' Propane Flame Control (Servo) Pin
  PropaneValvePin       = 24
  
' Quadrature Encoder (User Input) Pin
  Encoder1APin          = 25 
  Encoder1BPin          = 26 
' Reserved              = 27                         
' Reserved              = 28                         
' Reserved              = 29                         
' Reserved              = 30                         
  Encoder1ButtonPin     = 31

  digits                = 5                                'Number of digits to display(max is 8 digits)
  
  PropaneServoBasePeriod        = 1000
  PropaneOff                    = PropaneServoBasePeriod+0
  PropaneHigh                   = PropaneServoBasePeriod+1000
  
' Settings Variable Keys
  cCookingTemp        = "C"+("T"<<8)
  cCookingTime        = "C"+("t"<<8)
  
var
  long position[4]                                      'Read only for Quadrature Encoder (user input)
  long knobPosition                                     'User Input Knob Value
  long displayTemp                                      'Logical flag to indicate when the temperature should be displayed
  long monitorCogID                                     'Monitor Cog ID
  long myStack[100]                                     'Stack area for Monitor Cog
  long cookTemp,currentTemp,difference,cookTime
  long flame                                            'Sets how high the flame should be
  long lightingFire
  byte buf[10]                                          'Work area for 7-segment display
  
  
OBJ

  sevenseg      : "cr_LTC-4627JR"                       'Uses 1 cog
  temp          : "cr_MAX6675"
  delay         : "OBEX_Timing"
  tune          : "cr_SimpleTunes"
  Propane       : "Servo32v3"                           'Uses 1 cog
  encoder       : "Quadrature Encoder"                  'Uses 1 cog
  settings      : "obex_settings"
  xb            : "obex_XBee_Object"
   G            : "cr_Globals"       



PUB main | hh,mm
'------------------------------------------------------- Init xBee Communications   

  xb.start(cXBEErx,cXBEEtx,0,g#cBaud)       ' Start XBee Communication Link - RX,TX, Mode, Baud
  xb.AT_Init                                ' Initialize for fast AT command use - 5 second delay to perform
  xb.AT_Config(string("ATAP 0"))            ' Set for non-API mode (AT mode)
  xb.AT_Config(string("ATDN CYCLOPS"))      ' Set destination address to talk to node named RANGER
  xb.rxflush                                ' Throw out OK's from AT commands
  xb.str(string(g#CR,"BBQ Startup...",g#CR))

           
'------------------------------------------------------- Init Propane controls   
  flame    := propaneOff
  Propane.start
  Propane.Set(PropaneValvePin, PropaneOff)

'------------------------------------------------------- Init 7-segment Display

  sevenseg.start(lowDigitPin0, digits, SegmentPin0, true)
  sevenseg.SetDecimalPoint(-1)
  sevenseg.SetSegments(string("8888 "))
  
'------------------------------------------------------- Init frob knob 
  encoder.Start(Encoder1APin, 1, 1, @position)

'------------------------------------------------------- Retrieve settings from previous run
  settings.start
  cookTemp := settings.getLong(cCookingTemp)
  cookTime := settings.getLong(cCookingTime)

'------------------------------------------------------- Init tone generator
  tune.init(speakerPin)
  'tune.playTune(tune#cLightMyFire)  
  
'------------------------------------------------------- Set default values
  knobPosition := 0
  lightingFire := 100
  
'------------------------------------------------------- Init temperature monitoring 
  temp.start(so_data_pin, clk_pin, cs_rst_pin)         ' Isnitialize MAX6675 thermocouple interface
  displayTemp  := false
  monitorCogID := cognew(temperatureMonitor, @myStack) + 1





  
'------------------------------------------------------- Main loop

  repeat
    repeat
 
      knobPosition :=  1 #>  (knobPosition - Encoder.ReadDelta(0))  <# 08        'limit encoder value
     
      case knobPosition
      
'------------------------------------------------------- Monitor Mode

        01..02:                 'Monitor Temperature
            displayTemp := true                         'Enable TemperatureMonitor's display
            delay.pause1ms(100)                         'wait 
          
'------------------------------------------------------- Set Cooking Temperature Mode

        03..04:                                         'Allow user to set cooking temperature
          displayTemp := false                          'Disable TemperatureMonitor's display so we can use it
          showTemp(cookTemp)              
          delay.pause1ms(500)

          if readPin(Encoder1ButtonPin)==0
            delay.pause1ms(100)                         'allow time for button to settle
            tune.playTune(3)
            repeat while readPin(Encoder1ButtonPin)==1
              cookTemp :=  10 #>  (cookTemp - Encoder.ReadDelta(0))  <# 1000        'limit encoder value
              showTemp(cookTemp)              
              delay.pause1ms(500)                         
            sevenseg.setSegments(string("save "))
            tune.playTune(6)
            delay.pause1ms(1000)                         'allow time for user to see message
            settings.setLong(cCookingTemp,cookTemp)
            settings.commit
           
                  
'------------------------------------------------------- Set Cooking Time Mode

        05..06:                                         'Allow user to set cooking time                               
          displayTemp := false                          'Disable TemperatureMonitor's display so we can use it
          sevenseg.setSegments(string("____:"))
          if readPin(Encoder1ButtonPin)==0              'Wait for button press
            delay.pause1ms(100)                         'allow time for button to settle
            tune.playTune(5)
            hh :=  cookTime /100
            mm :=  cookTime // 100
            repeat while readPin(Encoder1ButtonPin)==1
              hh :=  0 #>  (hh - Encoder.ReadDelta(0))  <# 99        'limit encoder value
              buf[0] := "0"+ hh / 10 // 10
              buf[1] := "0"+ hh / 1 // 10
              buf[2] := "_"
              buf[3] := "_"
              buf[4] := ":"
              buf[5] := 0
           
              sevenseg.setSegments(@buf)
              delay.pause1ms(500)                         
              
            repeat while readPin(Encoder1ButtonPin)==0  'Wait for second button press
            delay.pause1ms(100)                         'allow time for button to settle
           
            repeat while readPin(Encoder1ButtonPin)==1
              mm :=  0 #>  (mm - Encoder.ReadDelta(0))  <# 99        'limit encoder value
              buf[0] := "0"+ hh / 10 // 10
              buf[1] := "0"+ hh / 1  // 10
              buf[2] := "0"+ mm / 10 // 10
              buf[3] := "0"+ mm / 1  // 10
              buf[4] := ":"
              buf[5] := 0
           
              sevenseg.setSegments(@buf)
              delay.pause1ms(500)                         
              
            sevenseg.setSegments(string("save "))           
            settings.setLong(cCookingTime,cookTime)
            settings.commit
            tune.playTune(6)
          
'------------------------------------------------------- Light the Fire Mode

        07..08:                                         'Override safeties long enough to light the fire
          displayTemp := false                          'Disable TemperatureMonitor's display so we can use it
          sevenseg.setSegments(string("lite "))
          lightingFire := 100                           'Disable emergency shutoff for 'n' seconds

'------------------------------------------------------- Someting Went Wrong Mode

        other :                'Something unexpected happened. Shut off the gas and call for help!
          emergencyShutoff
        
    delay.pause1ms(100)                             ' wait 

pub showTemp(temperature) | i
''   ┌───────────────────────────────────────────────────────────────────
''   │ Converts the passed value into a character string and appends the
''   │ unit indicator "F", then sends the result to the display.  
''   └───────────────────────────────────────────────────────────────────
 
  buf[0] := "0"+temperature / 100 // 10                 'Get 1st digit of number and convert to ascii
  buf[1] := "0"+temperature / 10 // 10                  'Get 2nd digit of number and convert to ascii
  buf[2] := "0"+temperature / 1 // 10                   'Get 3rd digit of number and convert to ascii
  
  buf[3] := "F"                                         'Add the Fahrenheit indicator
  buf[4] := "°"                                         'Add the Degree symbol
  
  buf[5] := 0                                           'Null terminate

  i:=0
  repeat while buf[i] == "0"                            'Supress leading zeros
      buf[i++] := " "
   
  sevenseg.setSegments(@buf)                            'Send the result to the display
  xb.str(@buf)
  xb.str(string(g#CR))

  
pub temperatureMonitor  | i
''   ┌───────────────────────────────────────────────────────────────────
''   │ This routine runs in a seperate cog. It monitors the current  
''   │ temperature and compares it to the desired cooking temperature  
''   │ If it is low or high, it adjusts the flame to increase or decrease  
''   │ the temperature. It also watches to ensure that the flame  
''   │ adjustments are effective. If not, something is wrong. In this  
''   │ case, it calls the emergency shutoff function to kill the fire  
''   │ and signal that it needs help. 
''   └───────────────────────────────────────────────────────────────────
     
    repeat 
  
      high(PropaneDeadManCutoff)
      currentTemp := temp.gettempf/10                   'Get the temperature and remove the tenths digit

      if displayTemp == true                            'If no one else is using the display, show the current temp
        showTemp(currentTemp++)              
      
      difference := currentTemp - cookTemp              'Calculate the difference between the current temperature
      case difference

          -10..10   :                                   'if in the "sweet zone", do nothing
          NEGX..-10 : flame := flame + 5                ' else increase 
          10..POSX  : flame := flame - 5                '  or decrease the flame

      lightingFire := --lightingFire #> 0
      if lightingFire > 0
        high(igniterPin)
        'sevenseg.setvalue(lightingFire)
      else
        low(igniterPin)
      
      if (currentTemp < 120) and NOT (lightingFire)  'If the flame is on and the temp is low and we are NOT lighting the fire
        ''emergencyShutoff                                              'Shut it off!!!

      Propane.Set(PropaneValvePin, flame )              'adjust the flame
             
      delay.pause1ms(1000)                              ' wait a second, then do it again



pub emergencyShutoff            
''   ┌───────────────────────────────────────────────────────────────────
''   │ Something unexpected happened. Shut off the gas and call for help!  
''   │ Put a flashing error message on the display and play an error 
''   │ alarm sound. Continue this till help comes.
''   └───────────────────────────────────────────────────────────────────

  flame := propaneOff                                   'set flame to off
  Propane.Set(PropaneValvePin, flame )                  
  low(PropaneDeadManCutoff)

  xb.str(string(g#CR,"Emergency Shutoff",g#CR))

  repeat until lightingFire
    sevenseg.setSegments(string("err  "))               'Show the error
    delay.pause1ms(1000)                              
    sevenseg.setSegments(string("gas  "))
    delay.pause1ms(1000)                              
    sevenseg.setSegments(string("was  "))
    delay.pause1ms(1000)                              
    sevenseg.setSegments(string("shut "))
    delay.pause1ms(1000)                              
    sevenseg.setSegments(string("off  "))
    delay.pause1ms(1000)                              
     
      
PRI readPin(pin)
'   ┌───────────────────────────────────────────────────────────────────
'   │ Reads the value of a pin  
'   └───────────────────────────────────────────────────────────────────

  dira[pin]~                                           ' make an input
  return ina[pin]                                       
  
PRI high(pin)
'   ┌───────────────────────────────────────────────────────────────────
'   │ Sets a pin to a high state  
'   └───────────────────────────────────────────────────────────────────

  dira[pin]~~                                           ' make an output
  outa[pin]~~                                           ' write "1" to pin


PRI low(pin)
'   ┌───────────────────────────────────────────────────────────────────
'   │ Sets a pin to a low state  
'   └───────────────────────────────────────────────────────────────────

  dira[pin]~~                                           ' make an output
  outa[pin]~                                            ' write "0" to pin


  